﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class JetskiController : MonoBehaviour {

    // DEĞİŞKENLER

    public float Speed_forward = 1.0f;
    public float Speed_turn = 1.0f;
    public GameObject dyingParticle;
    private Vector3 hitTransform;
    public ParticleSystem jetskiParticle;


    private UI_Controller Mobile_Gas;
    private UI_Controller Mobile_Brake;
    private UI_Controller Mobile_Right;
    private UI_Controller Mobile_Left;

    void Start()
    {
        Mobile_Gas = CameraController.instance.Mobile_Gas;
        Mobile_Brake = CameraController.instance.Mobile_Brake;
        Mobile_Right = CameraController.instance.Mobile_Right;
        Mobile_Left = CameraController.instance.Mobile_Left;

    }


    public void Update()
    {

        float speed2 = (Input.GetAxis("Vertical") + GetMobileGas()) < 0 ? (Input.GetAxis("Vertical") + GetMobileGas()) / 2 : (Input.GetAxis("Vertical") + GetMobileGas());
        

        transform.position += transform.forward * (speed2 * -Speed_forward * Time.deltaTime);
        transform.Rotate(new Vector3(0,Time.deltaTime * (Input.GetAxis("Horizontal") + GetMobileSteer()) * Speed_turn, 0));

        if ((Input.GetAxis("Vertical") + Mobile_Gas.Power) != 0 )
            jetskiParticle.gameObject.SetActive(true);
        else
            jetskiParticle.gameObject.SetActive(false);

        // Taşlara çarpıp çapmadığını kontrol et
        if (transform.position.x <= -6.6)
            transform.position = new Vector3(-6.6f, transform.position.y, transform.position.z);
        else if (transform.position.x >= 26)
            transform.position = new Vector3(26, transform.position.y, transform.position.z);

        if (transform.position.z <= -6.22f)
            transform.position = new Vector3(transform.position.x, transform.position.y, -6.22f);
        else if (transform.position.z >= 27.9f)
            transform.position = new Vector3(transform.position.x, transform.position.y, 27.9f);

    }


    private float GetMobileSteer()
    {
        if (Mobile_Left.isPressed && !Mobile_Right.isPressed)
        {//left
            return -Mobile_Left.Power;
        }
        else if (!Mobile_Left.isPressed && Mobile_Right.isPressed)
        {//right
            return Mobile_Right.Power;
        }
        else
        {//multi
            return (-Mobile_Left.Power + Mobile_Right.Power) / 2;
        }

    }

    private float GetMobileGas()
    {
        if (Mobile_Gas.isPressed && !Mobile_Brake.isPressed)
        {//Gas
            return Mobile_Gas.Power;
        }
        else if (!Mobile_Gas.isPressed && Mobile_Brake.isPressed)
        {//brake
            return -Mobile_Brake.Power;
        }
        else
        {//multi
            return (-Mobile_Brake.Power + Mobile_Gas.Power) / 2;
        }

    }

    void OnCollisionEnter(Collision other)
    {
        if(other.collider.tag == "Engel")
        {
            hitTransform = other.contacts[0].point;
            Death();
        }

    }

    void Death()
    {
        GameObject spawnedParticle = Instantiate(dyingParticle, hitTransform, transform.rotation) as GameObject;
      //  Debug.Log("You are dead.");
        spawnedParticle.GetComponent<ParticleSystem>().Play();
        // Ölüm animasyonu
    }
    
}
