﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

public class PhotonNetworkManager : MonoBehaviour
{

    public static PhotonNetworkManager instance;


    public InputField RoomNameInput;
    public GameObject RoomPrefab;

    public GameObject Event_System;

    private bool isJoinedLobby = false;

    void Awake()
    {
        if (instance == null)
        {
            instance = this;

        }
        else if (instance != this)
        {
            Destroy(gameObject);
        }

    }

    void Start()
    {
        PhotonNetwork.ConnectUsingSettings("1.0");

        SceneManager.sceneLoaded += (a,s) => 
        {
            if (a.name == "MP_Scene")
            {
                Spawn();
            }
            if (a.name == "Menu")
            {

                try
                {
                    Destroy(gameObject);
                }
                catch (System.Exception)
                {

                    throw;
                }
               
            }
        };
    }

    public void Spawn()
    {
        int rndm = Random.Range(0, GameObject.Find("SpawnPositions").transform.childCount);
        GameObject g = PhotonNetwork.Instantiate("JetSki", GameObject.Find("SpawnPositions").transform.GetChild(rndm).position, GameObject.Find("SpawnPositions").transform.GetChild(rndm).rotation, 0);
        GameObject.FindGameObjectWithTag("MainCamera").GetComponent<CameraController>().target = g.transform;
        g.GetComponent<PlayerNetworkScript>().texture_indx = Random.Range(0, g.GetComponent<PlayerNetworkScript>().textures.Length);
        g.GetComponent<PhotonView>().RPC("ChangeName", PhotonTargets.AllBuffered, SystemInfo.deviceUniqueIdentifier,g.GetComponent<PlayerNetworkScript>().texture_indx);

    }

    void OnJoinedLobby()
    {
        isJoinedLobby = true;

        Invoke("RefreshRooms", 0.1f);
    }

    void OnJoinedRoom()
    {
        Debug.Log("You are joined room!");
        SceneManager.LoadScene("MP_Scene");
    }

    public void ButtonEvents(string EVENT)
    {

        if (EVENT == "CreateRoom")
        {
            if (isJoinedLobby)
            {
                if (RoomNameInput.text.Length > 1)
                {


                    RoomOptions RO = new RoomOptions();
                    RO.MaxPlayers = 8;
                    PhotonNetwork.CreateRoom(RoomNameInput.text,RO,TypedLobby.Default);
                    Event_System.SetActive(false);


                }
            }

        }
        else if (EVENT == "RefreshRooms")
        {
            RefreshRooms();
        }
        else if (EVENT == "")
        {

        }
        else if (EVENT == "")
        {

        }
        else if (EVENT == "")
        {

        }
        else if (EVENT == "")
        {

        }
        else if (EVENT == "")
        {

        }
        else if (EVENT == "")
        {

        }
        else if (EVENT == "")
        {

        }



    }

    [HideInInspector]
    public List<Transform> Rooms = new List<Transform>();

    void RefreshRooms()
    {
        foreach (Transform t in Rooms)
        {
            Destroy(t.gameObject);

        }
        Rooms.Clear();

        for (int i = 0; i < PhotonNetwork.GetRoomList().Length; i++)
        {
            if (PhotonNetwork.GetRoomList().Length >= 1)
            {

                GameObject _room = (GameObject)Instantiate(RoomPrefab);
                _room.transform.SetParent(RoomPrefab.transform.parent);
                _room.transform.position = RoomPrefab.transform.position;
                _room.transform.localScale = RoomPrefab.transform.localScale;
                _room.transform.rotation = RoomPrefab.transform.rotation;
                _room.name = PhotonNetwork.GetRoomList()[i].name;
                _room.transform.GetChild(0).GetComponent<Text>().text = PhotonNetwork.GetRoomList()[i].name + "   -   " + PhotonNetwork.GetRoomList()[i].playerCount + "/" + PhotonNetwork.GetRoomList()[i].maxPlayers;

                Vector3 curPos = _room.transform.localPosition;
                _room.transform.localPosition = new Vector3(curPos.x, 300 + (i * 87), curPos.z);

                Button _btn = _room.GetComponent<Button>();
                _room.GetComponent<Button>().onClick.AddListener(() => { RoomButtonClick(_btn); });

                Rooms.Add(_room.transform);
                _room.SetActive(true);

            }
        }

    }

    void RoomButtonClick(Button btn)
    {
        Event_System.SetActive(false);
        PhotonNetwork.JoinRoom(btn.gameObject.name);
    }

    void OnGUI()
    {
        GUILayout.Label(PhotonNetwork.connectionStateDetailed.ToString());
    }
}
